<script lang="ts">
  import type { CardId } from "server";
  import { send, receive } from "./util/crossfade";
  import CardBack from "./CardBack.svelte";

  export let deck: CardId[];
</script>

<div class="deck">
  {#each deck as cardId, idx (cardId)}
    <div
      class="card"
      style={`
        transform: translate(-${idx * 0.1}em, -${idx * 0.1}em);
        z-index: ${idx};
      `}
    >
      <div in:receive={{ key: cardId }} out:send={{ key: cardId }}>
        <CardBack />
      </div>
      {#if idx === deck.length - 1}
        <div class="size-wrapper">
          <div class="size">&times; {deck.length}</div>
        </div>
      {/if}
    </div>
  {/each}
</div>

<style>
  .deck {
    position: relative;
    height: 14em;
    width: 10em;
  }

  .card {
    position: absolute;
  }

  .size-wrapper {
    top: -14em;
    position: relative;
    height: 14em;
    width: 10em;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  .size {
    padding: 0.1em 0.3em;
    font-size: 2.5em;
    background-color: whitesmoke;
    border-radius: 0.4rem;
    display: flex;
    align-items: center;
    justify-content: center;
  }
</style>
